/* schedule.js - API library for schedule time configuration */

/* Copyright 2010 - 2013 TeamF1, Inc. */

function scheduleFormValidate ()
    {
    var obj = null;
    var time = 0;
	/* get and validate start hours */
	obj = document.getElementById('txtSchedStartTimeHrs');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid start time for schedule. Enter valid hour between 1 and 12",
                            1, 12, true, "Invalid start time for schedule.", "hours") == false)
         return false;
	/* get and validate start minutes */
	obj = document.getElementById('txtSchedStartTimeMns');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid start time for schedule. Enter valid minutes between 0 and 59",
                            0, 59, true, "Invalid start time for schedule.", "minutes") == false)
         return false;
	/* get and validate end hours */
	obj = document.getElementById('txtSchedEndTimeHrs');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid end time for schedule. Enter valid hour between 1 and 12",
                            1, 12, true, "Invalid end time for schedule.", "hours") == false)
         return false;
	/* get and validate end hours */
	obj = document.getElementById('txtSchedEndTimeMns');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid end time for schedule. Enter valid minutes between 0 and 59",
                            0, 59, true, "Invalid end time for schedule.", "minutes") == false)
         return false;
    
    var rdbObj = document.getElementById('rdbSpecDays')
    if (rdbObj && rdbObj.checked)
        {
        if (!isChkboxEnabled ('chkSunday chkMonday chkTuesday chkWednesday chkThursday chkFriday chkSaturday', 1, ""))
            {
            alert("Please select any Specific Day(s) on which this schedule to be Active");
            return false;
            }
        }
    var rbselVal = radioCheckedValueGet ('Schedules.AllDay');
    if(rbselVal && (parseInt(rbselVal, 10) == 0))
        {
        	if (timeValidate () == false)
        	    return false;
         }                  
    return true;
    }


function numObj (id, minLen, minVal, maxVal, errMsg)
	{
	this.id = id;
	this.minLen = minLen;
	this.minVal = minVal;
	this.maxVal = maxVal;
	this.errMsg = errMsg;
	}

function dateValidate (hoursId, minId, errObjId)
	{
	var dtVarObj = new Array ();
	
	dtVarObj[0] = new numObj(hoursId, 1, 1, 12, "Invalid Hours: Please enter a value between 1 - 12");
	dtVarObj[1] = new numObj(minId, 1, 0, 59, "Invalid Minutes: Please enter a value between 0 - 59");
	
	var idObj = null;
	for (var idx = 0; idx < dtVarObj.length; ++idx)
		{
		idObj = document.getElementById (dtVarObj[idx].id);
		if (!idObj || idObj.disabled) continue;
		if ((idObj.value.length < dtVarObj[idx].minLen) ||
			(parseInt (idObj.value, 10) < dtVarObj[idx].minVal) ||
			((dtVarObj[idx].maxVal != 0) && (parseInt (idObj.value, 10) > dtVarObj[idx].maxVal)))
			{
			if (document.getElementById(errObjId))
				document.getElementById(errObjId).innerHTML = dtVarObj[idx].errMsg
			else
				alert (dtVarObj[idx].errMsg);
			idObj.focus ();
			return false;
			}
		}
	//document.getElementById(errObjId).innerHTML = "";
	return true;
	}

function pageValidate ()
    {
        
	if (specificDaySelectionCheck () == false)
		return false;

    var selValue = radioCheckedValueGet ('Schedules.AllDay');
	if (!selValue) return;
	if (parseInt(selValue, 10) == 0)
		{
	    if (dateValidate ('txtSchedStartTimeHrs', 'txtSchedStartTimeMns','date1Err') == false)
	  		return false;
	  	if (dateValidate ('txtSchedEndTimeHrs', 'txtSchedEndTimeMns','date2Err') == false)
	   		return false;

		if (parseInt (selValue, 10) == 0)
			{
	   		if (!timeValidate ())
	   			return false;
	   		}
	   	else
	   		{
             if(document.getElementById('date2Err'))
                 document.getElementById('date2Err').innerHTML = "";
	   		}
   		}
	return true;
    }


function timeValidate ()
    {
    
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please check minutes';
    var errMsgL10n2 = 'End hour cannot be less than the start hour';    
    var errMsgL10n3 = 'End Time hours cannot extend to next day'; 
    var errMsgL10n4 = 'End Time hours and Start Time hours should not be same';
    /* L10N Error Message Collection End */
    
    var meridian1 = parseInt (document.getElementById('selStartMeridian').value, 10);
    var meridian2 = parseInt (document.getElementById('selEndMeridian').value, 10);
    var hr1 = parseInt (document.getElementById('txtSchedStartTimeHrs').value, 10);
    var hr2 = parseInt (document.getElementById('txtSchedEndTimeHrs').value, 10);
	var min1 = parseInt (document.getElementById('txtSchedStartTimeMns').value,10);
    var min2 = parseInt (document.getElementById('txtSchedEndTimeMns').value,10);
    if (hr1 == hr2 && min1 == min2 && meridian1 == meridian2)
      {
      alert(errMsgL10n4);
      return false;
      }
    
    /* Converting into 24hrs Format */
    if (meridian1 == 1 && hr1 != 12) hr1 = hr1 + 12;
    if (meridian1 == 0 && hr1 == 12) hr1 = 0;
    if (meridian2 == 1 && hr2 != 12) hr2 = hr2 + 12;
    if (meridian2 == 0 && hr2 == 12) hr2 = 0; 
    
    /* Special Case for 12:00 to 00:00 */
    if (hr2 == 0 && min2 == 0) hr2 = 24;
    
	if (hr1 > hr2)
		{
		if (hr1 >= 12 && (hr2 > 0 || min2 > 0))
			{
			alert (errMsgL10n3);
			return false;
			}
		else
			{
			alert (errMsgL10n2);
			return false;
			}
		}
	else if (hr1 == hr2 && min1 > min2)
		{
		alert (errMsgL10n2);
		return false;
		}

	return true;
	}

function specificDaySelectionCheck ()
	{
    var selValue= radioCheckedValueGet ('Schedules.allDays');
	if (!selValue) return;
	if (parseInt(selValue, 10) == 0)
		{
        if (document.getElementById('chkSunday').checked ||
            document.getElementById('chkMonday').checked ||
            document.getElementById('chkTuesday').checked ||
            document.getElementById('chkWednesday').checked ||
            document.getElementById('chkThursday').checked ||
            document.getElementById('chkFriday').checked ||
            document.getElementById('chkSaturday').checked)
			return true;
		else
			{
			errMag = 'Please select day(s) on which this schedule should apply.';
			if (document.getElementById ('errMsg'))
				document.getElementById ('errMsg').innerHTML = errMag;
			else
				alert (errMag);
			return false;
			}
		}
	return true;
	}


function scheduleDayOptCheck ()
	{
	var selValue= radioCheckedValueGet ('Schedules.allDays');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* specific day */
			fieldStateChangeWr ('','','','tblScheduleDays');
			break;
		case 1:	/* all day */
			fieldStateChangeWr ('','tblScheduleDays','','');
			break;
		}
	}
function scheduleTimeOptCheck ()
	{
	var selValue2 = radioCheckedValueGet ('Schedules.AllDay');
	if (!selValue2) return;
	switch (parseInt(selValue2, 10))
		{
		case 0:	/* specific times */
			fieldStateChangeWr ('','','','tblScheduleTime');
			break;
		case 1:	/* all day */
			fieldStateChangeWr ('','tblScheduleTime','','');
			break;
		}
	}

function scheduleInit ()
	{
	scheduleDayOptCheck ();
	scheduleTimeOptCheck ();
	}
