/* vpnPolicy_IPv6.js - API library for VPN Policy IPv6 configuration */

/* Copyright 2012 TeamF1, Inc. */

/*
modification history 
------------------------
01a,16-JAN-12,mvb  written. 
*/

/* add_vpn_policy.htm and edit_vpn_policy.htm */
function editVpnPolicyValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a name for the VPN policy';
    var errMsgL10n2 = 'Invalid FQDN. Please specify a Fully Qualified Domain Name for the remote endpoint';
    var errMsgL10n3 = 'Please enter a valid incoming SPI for manual policy entry';
    var errMsgL10n4 = 'Please enter the incoming encryption check key for manual policy entry';
    var errMsgL10n5 = 'Please enter the outgoing encryption key for manual policy entry';
    var errMsgL10n6 = 'Please enter a valid outgoing SPI for manual policy entry';
    var errMsgL10n7 = 'Please enter the incoming integrity key for manual policy entry';
    var errMsgL10n8 = 'Please enter the outgoing integrity check key for manual policy entry';
    var errMsgL10n9 = 'SA lifetime value should not exceed 10 digits';
    var errMsgL10n10 = 'seconds';
    var errMsgL10n11 = 'kilo bytes';
    var errMsgL10n12 = 'Please enter a valid SA lifetime in';
    var errMsgL10n24 = 'No IKE Policy to Configure VPN Policy, Please Configure an Ike Policy';
    var errMsgL10n25 = 'Keep Alive Enable Option Only for Auto Policy. Please select "No" for Manual policy.';
    var errMsgL10n26 = 'Keep alive can not be enabled as the IKE policy selected is configured as Responder only';    

     /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtVPName," +
                       errMsgL10n1;
    txtFieldIdArr[1] = "vpnPolicyRemoteEndpointFQDNTxt," + 
                       errMsgL10n2;
    txtFieldIdArr[2] = "txtVPSPIIn," + 
                       errMsgL10n3;
    txtFieldIdArr[3] = "manualPolicyKeyIn," + 
                       errMsgL10n4;
    txtFieldIdArr[4] = "manualPolicyKeyOut," + 
                       errMsgL10n5;
    txtFieldIdArr[5] = "txtVPSPIOut," + 
                       errMsgL10n6;
    txtFieldIdArr[6] = "txtVPIntKeyIn," + 
                       errMsgL10n7;
    txtFieldIdArr[7] = "txtVPIntKeyOut," + 
                       errMsgL10n8;
    txtFieldIdArr[8] = selAutoIkePol+"," + 
                       errMsgL10n24;  

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    var txtFieldIdSpaceCheckArr = new Array ();
    txtFieldIdSpaceCheckArr[0] = "txtVPName,";
    if (isProblemCharArrayCheck (txtFieldIdSpaceCheckArr) == false)
         return false;
            
   var selectPolicyType = document.getElementById('selectPolicyType').value;
    var rdbKeepaliveEnable = document.getElementById('rdbKeepaliveEnable');
    if(rdbKeepaliveEnable &&  rdbKeepaliveEnable.checked && selectPolicyType == "2"){
    	alert(errMsgL10n25);
    	return false;
    }

    var selectedValueObj = document.getElementById('selAutoIkePol');
    var selectedValue;
    if(selectedValueObj)
        {
        selectedValue = selectedValueObj.value;
        }
    var count = 0;
    var countObj = document.getElementById('hdIkeCount');
    if(countObj) count = countObj.value;
    if(selectedValue && rdbKeepaliveEnable &&  rdbKeepaliveEnable.checked && count > 0){
       for(i=1;i<=count;i++){
                var custServiceName = document.getElementById('hdIkeName'+i).value;
                if(selectedValue == custServiceName){
                  alert(errMsgL10n26);
                  return false;
                }
             }
      }

    var saLifeTimeSecObj = document.getElementById('txtVPSALifeTimeSec');
    if (saLifeTimeSecObj && !saLifeTimeSecObj.disabled)
        {
        if (saLifeTimeSecObj.value.length > 10)
            {
            alert (errMsgL10n9)
            return false;
            }
        var suffix = errMsgL10n10;
        var type = comboSelectedValueGet ('selSaLifetimeType');
        if (type != null)
            {
            switch (parseInt (type, 10))
                {
                case 1:
                    suffix = errMsgL10n11;
                    break;
                default:
                    break;
                }
            }
        if (numericValueRangeCheck (saLifeTimeSecObj, 1, 
                                errMsgL10n12+" " + suffix,
                                '', '', false, "", "") == false)
            return false;
        }
    var selLocObj = document.getElementById("selTrafficLocalIp");
    var selRemObj = document.getElementById("selectRemoteIP");
    var locIpType = (selLocObj.selectedIndex == 3)?"SN":"IP";
    var remIpType = (selRemObj.selectedIndex == 3)?"SN":"IP";
    
    /* L10N Error Message Collection Start */
    var errMsgL10n13 = 'Invalid IP address for remote endpoint.';
    var errMsgL10n14 = 'for octet';
    var errMsgL10n15 = 'Invalid  local starting IP address';
    var errMsgL10n16 = 'Invalid  local ending IP address.';
    var errMsgL10n17 = 'Invalid local IP subnet mask';
    var errMsgL10n18 = 'Invalid  remote starting IP address.';
    var errMsgL10n19 = 'Invalid  remote ending IP address';
    var errMsgL10n20 = 'Invalid remote IP subnet mask';
    var errMsgL10n21 = 'Invalid Detection Period:';
    var errMsgL10n22 = 'Invalid Reconnect after failure count:';    
    var errMsgL10n23 = 'Invalid Keep Alive IP address'
    /* L10N Error Message Collection End */
    
    /* validate all IP addresses: check for empty and invalid values */
    
    var objRmtEndPoint = document.getElementById('vpnPolicyRemoteendpointIPAddress');
    if(objRmtEndPoint && !(objRmtEndPoint.disabled))
        {
        if (ipv6Validate ('vpnPolicyRemoteendpointIPAddress', false, true, '') == false)
            return false;
        }
    
    var objKeepAlive = document.getElementById('keepaliveIPAddress');
    if(objKeepAlive && !(objKeepAlive.disabled))
        {    
        if (ipv6Validate ('keepaliveIPAddress', false, true, '') == false)
	        return false;
	    }
	    
    var objlclStartIP = document.getElementById('localStartIP');
    if(objlclStartIP && !(objlclStartIP.disabled))
        {   
        if (ipv6Validate ('localStartIP', false, true, '') == false)
            return false;
        }
        
    var objlclEndIP = document.getElementById('localEndIP');
    if(objlclEndIP && !(objlclEndIP.disabled))
        {
        if (ipv6Validate ('localEndIP', false, true, '') == false)
            return false;
        }
    
    var objlclPrefix = document.getElementById('txtPreLen_lcl');
    if(objlclPrefix && !(objlclPrefix.disabled))
        {
        if (numericValueRangeCheck (objlclPrefix, '', '', 0, 128, true, '', '') == false)
            return false;
        }
    
    var objrmtStartIP = document.getElementById('remoteStartIP');
    if(objrmtStartIP && !(objrmtStartIP.disabled))
        {
        if (ipv6Validate ('remoteStartIP', false, true, '') == false)
            return false;
        }
        
    var objrmtEndIP = document.getElementById('remoteEndIP');
    if(objrmtEndIP && !(objrmtEndIP.disabled))
        {
        if (ipv6Validate ('remoteEndIP', false, true, '') == false)
            return false;
        }
    
    var objrmtPrefix = document.getElementById('txtPreLen_rmt');
    if(objrmtPrefix && !(objrmtPrefix.disabled))
        {
        if (numericValueRangeCheck (objrmtPrefix, '', '', 0, 128, true, '', '') == false)
            return false;
        }
      
    if (spiLenValidate () == false)
        return false;

    if (encrKeyLenValidate () == false)
        return false;
    if (intgAlgoKeyLenValidate () == false)
        return false;

    var selRemoteObj = document.getElementById ('selectRemoteIP');
    if (!selRemoteObj) return;  /* do not check for disable state */
    selRemoteObj.disabled = false;
    if( saValueRangeCheck () == false)
        return false;
    
    if(pingIPsameSubnetCheck () == false)
       return false;
    
    if(numericValueRangeCheck (document.getElementById ('txtDetectionPeriod'), '', '', 10, 999, true, errMsgL10n21, '') == false)
        return false;
    if(numericValueRangeCheck (document.getElementById ('txtReconnectCount'), '', '', 3, 99, true, errMsgL10n22, '') == false)
        return false;
    return true;
    }
function spiLenValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n13 = 'Incoming SPI value must be 3 to 8 characters long';
    var errMsgL10n14 = 'Outgoing SPI value must be 3 to 8 characters long';
     var errMsgObjL10n = document.getElementById ('hd.incomSpiValBetVpn');

    /* L10N Error Message Collection End*/

    var spiInObj = document.getElementById ('txtVPSPIIn');
    var spiOutObj = document.getElementById ('txtVPSPIOut');
    if (!spiInObj || !spiOutObj || spiInObj.disabled || spiOutObj.disabled) return true;

    if (((spiInObj.value.indexOf ("0x") == 0 || spiInObj.value.indexOf ("0X") == 0) && (spiInObj.value.length < 5 || spiInObj.value.length > 10)) ||
        (spiInObj.value.indexOf ("0x") == -1 && spiInObj.value.indexOf ("0X") == -1 && (spiInObj.value.length < 3 || spiInObj.value.length > 8)))
        {
        alert (errMsgL10n13+" ");
        spiInObj.focus();
        return false;
        }
    if (((spiOutObj.value.indexOf ("0x") == 0 || spiOutObj.value.indexOf ("0X") == 0) && (spiOutObj.value.length < 5 || spiOutObj.value.length > 10)) ||
        (spiOutObj.value.indexOf ("0x") == -1 && spiOutObj.value.indexOf ("0X") == -1 && (spiOutObj.value.length < 3 || spiOutObj.value.length > 8)))
        {
        alert (errMsgL10n14+" ");
        spiOutObj.focus();
        return false;
        }
    return true;
    }

function encrKeyLenValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'for encryption algorithm: DES. Key must be 8 characters long.';    
    var errMsgL10n2 = 'for encryption algorithm: 3DES. Key must be 24 characters long.';    
    var errMsgL10n3 = 'for encryption algorithm: AES-128. Key must be 16 characters long.';    
    var errMsgL10n4 = 'for encryption algorithm: AES-192. Key must be 24 characters long.';    
    var errMsgL10n5 = 'for encryption algorithm: AES-256. Key must be 32 characters long.';    
    var errMsgL10n6 = 'Invalid Key-In length';    
    var errMsgL10n7 = 'Invalid Key-Out length';    
    var errMsgL10n8 = 'For 3DES, every 8 bytes in 24 byte key-in should be different';    
    var errMsgL10n9 = 'For 3DES, every 8 bytes in 24 byte key-out should be different';        
     /* L10N Error Message Collection End */

    var selEncrValue = comboSelectedValueGet ('selectManualPolicyEncAlg');
    if (selEncrValue == null)
         return true;
    var minKeyLen = 0;
    var errStr = "";
    switch (parseInt (selEncrValue, 10))
        {
        case 1:    /* DES */
            minKeyLen = 8;
            errStr = errMsgL10n1;
            break;
        case 2:    /* 3DES */
            minKeyLen = 24;
            errStr = errMsgL10n2;
            break;
        case 3:    /* AES-128 */
            minKeyLen = 16;
            errStr =errMsgL10n3;
            break;
        case 4:    /* AES-192 */
            minKeyLen = 24;
            errStr =errMsgL10n4;
            break;
        case 5:    /* AES-256 */
            minKeyLen = 32;
            errStr = errMsgL10n5;
            break;
        case 0:    /* NULL */
        default:
            minKeyLen = 0;
            errStr = "";
            break;
        }
    /* check for minimum length */
    if (fieldLengthCheck ('manualPolicyKeyIn', minKeyLen, minKeyLen,
                errMsgL10n6+" " + errStr) == false)
        return false;
    if (fieldLengthCheck ('manualPolicyKeyOut', minKeyLen, minKeyLen,
                errMsgL10n7+" " + errStr) == false)
        return false;
    /* check for key validity */
    var keyInObj = document.getElementById ('manualPolicyKeyIn');
    if (keyInObj.disabled) return true;
    var keyOutObj = document.getElementById ('manualPolicyKeyOut');
    if (keyOutObj.disabled) return true;
    switch (parseInt (selEncrValue, 10))
        {
        case 2:    /* 3DES */
            splitPos = 8;
            errStr = errMsgL10n8;
            var keyInStr = keyInObj.value;
            if ((keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos, splitPos + splitPos)) ||
                (keyInStr.substring (splitPos, splitPos + splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)) ||
                (keyInStr.substring (0, splitPos) == 
                         keyInStr.substring (splitPos  + splitPos)))
                {
                alert (errStr);
                keyInObj.focus ();
                return false;
                }
            var keyOutStr = keyOutObj.value;
            errStr = errMsgL10n9;
            if ((keyOutStr.substring (0, splitPos) == 
                         keyOutStr.substring (splitPos, splitPos + splitPos)) || 
                (keyOutStr.substring (splitPos, splitPos + splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)) || 
                (keyOutStr.substring (0 , splitPos) == 
                         keyOutStr.substring (splitPos  + splitPos)))
                {
                alert (errStr);
                keyOutObj.focus ();
                return false;
                }
            break;
        case 1:    /* DES */
        case 3:    /* AES-128 */
        case 4:    /* AES-192 */
        case 5:    /* AES-256 */
        case 0:    /* NULL */
        default:
            minKeyLen = 0;
            errStr = "";
            break;
        }
    
    return true;
    }    
    
function intgAlgoKeyLenValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'for integrity algorithm: MD5. Key must be 16 characters long.';     
    var errMsgL10n2 = 'for integrity algorithm: SHA1. Key must be 20 characters long.';       
    var errMsgL10n3 = 'Invalid Key-In length';    
    var errMsgL10n4 = 'Invalid Key-Out length';        
    /* L10N Error Message Collection End */    
    
    var selAlgoValue = comboSelectedValueGet ('selInetegrityAlgo');
    if (selAlgoValue == null) return true;
    var minKeyLen = 0;
    var errStr = "";
    switch (parseInt (selAlgoValue, 10))
        {
        case 1:    /* MD5 */
            minKeyLen = 16;
            errStr = errMsgL10n1;
            break;
        case 2:    /* SHA1 */
            minKeyLen = 20;
            errStr = errMsgL10n2;
            break;
        default:
            minKeyLen = 0;
            errStr = "";
            break;
        }
    if (fieldLengthCheck ('txtVPIntKeyIn', minKeyLen, minKeyLen,
            errMsgL10n3+" "+ errStr) == false)
        return false;
    if (fieldLengthCheck ('txtVPIntKeyOut', minKeyLen, minKeyLen,
            errMsgL10n4+" " + errStr) == false)
        return false;
    return true;
    }        

/* add_vpn_policy.htm */

function remoteIPChange ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'This field is not editable, because netbios is selected.';          

    /* L10N Error Message Collection End */     
    
    var chkObj = document.getElementById ('chkNetbios');
    if (!chkObj || chkObj.disabled) return;
    var selRemoteObj = document.getElementById ('selectRemoteIP');
    if (!selRemoteObj) return; /* do not check for disable state */
    if (chkObj.checked)
        {
        selRemoteObj.selectedIndex = 3;
        dropFieldSelectselectRemoteIP ();
        selRemoteObj.disabled = true;
        selRemoteObj.readOnly = true;
        document.getElementById('nbWarnMsg').innerHTML = errMsgL10n1;
        }
    else
        {
        //selRemoteObj.selectedIndex = 0;
        selRemoteObj.disabled = false;
        selRemoteObj.readOnly = false;
        document.getElementById('nbWarnMsg').innerHTML = "&nbsp;";
        dropFieldSelectselectRemoteIP ();
        }
    }
function autoPolicyPfsKey ()
    {
    depFieldCheck ('pfsKey', true, '', '', 'pfsKeyGroup', '');
    depFieldCheck ('pfsKey', false, 'pfsKeyGroup', '', '', '');
    }
function dropFieldSelectselectPolicyType ()
    {
    var selValue = comboSelectedValueGet ('selectPolicyType');
    var ikeDirVal = document.getElementById('ikeDirectionVal').value;
    if (selValue == null) return;
    switch (parseInt (selValue, 10))
        {
           case 1:    /* AUTO POLICY */
               fieldStateChangeWr ('', 'manualPolicy', '', 'autoPolicy');
               if(ikeDirVal == 1)
                  fieldStateChangeWr ('chkAutoInit', '', '', '');
	           else
		          fieldStateChangeWr ('', '', 'chkAutoInit', '');
               autoPolicyPfsKey ();
               viewChange();
               break;
           case 2:    /* MANUAL POLICY */
               fieldStateChangeWr ('chkAutoInit', 'autoPolicy', '', 'manualPolicy');  
               dropFieldSelectEncAlg ();
               break;
           default:
               break;
           }
     disLinkMsg ();      
    }
    
function dropFieldSelectselectLocalIP ()
    {
    var selValue = comboSelectedValueGet ('selTrafficLocalIp');
    if (selValue == null) return;
    switch (parseInt (selValue, 10))
           {
           case 0:
               fieldStateChangeWr ('localStartIP localEndIP txtPreLen_lcl', '', '', '');
               break;
           case 1:
               fieldStateChangeWr ('localEndIP txtPreLen_lcl', '', 'localStartIP', '');
               break;
           case 2:
               fieldStateChangeWr ('txtPreLen_lcl', '', 'localStartIP localEndIP', '');
               break;
           case 3:
               fieldStateChangeWr ('localEndIP', '', 'localStartIP txtPreLen_lcl', '');
               break;
           default:
               break;
           }
    }
function dropFieldSelectselectRemoteIP ()
    {
    var selValue = comboSelectedValueGet ('selectRemoteIP');
    if (selValue == null) return;
    switch (parseInt (selValue, 10))
           {
           case 0:
               fieldStateChangeWr ('remoteStartIP remoteEndIP txtPreLen_rmt', '', '', '');
               break;
           case 1:
               fieldStateChangeWr ('remoteEndIP txtPreLen_rmt', '', 'remoteStartIP', '');
               break;
           case 2:
               fieldStateChangeWr ('txtPreLen_rmt', '', 'remoteStartIP remoteEndIP', '');
               break;
           case 3:
               fieldStateChangeWr ('remoteEndIP', '', 'remoteStartIP txtPreLen_rmt', '');
               break;
           default:
               break;
           }
    }
function dropFieldSelectEncAlg ()
    {
       var optVal = comboSelectedValueGet ('selectManualPolicyEncAlg');
       if (optVal == null) return;
       switch (parseInt (optVal, 10))
           {
           case 0:
               fieldStateChangeWr ('manualPolicyKeyIn manualPolicyKeyOut', '', '', '');
               break;
           default:
               fieldStateChangeWr ('', '', 'manualPolicyKeyIn manualPolicyKeyOut', '');
               break;
           }
    }
    
    
function deleteOptions (selObj)
    {
    while(selObj.options.length != 0)
        selObj.options[0]=null;
    }

function remoteEndpointTypeCheck ()
    {
    var selValue = radioCheckedValueGet ('IpsecVPNPolicy.RemoteEndPointType');
    if (!selValue) return;
    switch (parseInt(selValue, 10))
        {
        case 1:    /* FQDN */
            fieldStateChangeWr ('vpnPolicyRemoteendpointIPAddress','','vpnPolicyRemoteEndpointFQDNTxt','');
            break;
        case 0:    /* IP Address */
            fieldStateChangeWr ('vpnPolicyRemoteEndpointFQDNTxt','','vpnPolicyRemoteendpointIPAddress','');
            break;
        }
    }

function viewChange()
    {
    var obj=document.getElementById("selAutoIkePol");
    if(obj.options.length==0||obj.disabled)
        {
        fieldStateChangeWr("btAutoPolicyViewSel","","","");
        }
    else
        {
        fieldStateChangeWr("","","btAutoPolicyViewSel","");
        value=obj.options[obj.selectedIndex].id;
        document.getElementById("btAutoPolicyViewSel").name="button.view.IpsecIKEPolicy.view_ike_policy."+value;
        }
    };


function disLinkMsg ()
    {
    var selectedAction = document.getElementById("selectPolicyType").value;
    var countOfPol = document.getElementById("selAutoIkePol");
    if (selectedAction == "1" && countOfPol.selectedIndex < 0)
    	{
        document.getElementById("lblWarning").innerHTML = "Please add <a href='?page=ike_policies_IPv6.htm'>IKE Policies</a> to get the list of IKE Policies here </span>";
        fieldStateChangeWr("btAutoPolicyViewSel","","","");
        }
    else
         document.getElementById("lblWarning").innerHTML = ""; 
    };

function vpnPolicyAddInitialSettings ()
    {
    remoteEndpointTypeCheck ();
    dropFieldSelectselectPolicyType ();
    dropFieldSelectselectLocalIP ();
    dropFieldSelectselectRemoteIP ();
    remoteIPChange ();
    var selIkePolObj = document.getElementById ('selAutoIkePol');
    if (!selIkePolObj || selIkePolObj.disabled || !selIkePolObj.length) return;
    viewChange();
    }

function keepaliveCheck ()
    {
    depFieldCheck ('rdbKeepaliveEnable', true, '','','txtReconnectCount txtDetectionPeriod keepaliveIPAddress','');
    depFieldCheck ('rdbKeepaliveEnable', false, 'txtReconnectCount txtDetectionPeriod keepaliveIPAddress','','','');
    depFieldCheck ('rdbKeepaliveDisable', true, 'txtReconnectCount txtDetectionPeriod keepaliveIPAddress','','','');
    depFieldCheck ('rdbKeepaliveDisable', false, '','','txtReconnectCount txtDetectionPeriod keepaliveIPAddress','');
    }

function VpnClientCheck6 ()
    {
        var errMsgL10n2 = 'This field is not editable, because for vpn client  remote selector should be ANY.'; 
    var chkObjvpn = document.getElementById ('vpnclient6').value;
    var selRemoteObj = document.getElementById ('selectRemoteIP');
     if (chkObjvpn == 1 )
        {
        selRemoteObj.selectedIndex = 0;
        dropFieldSelectselectRemoteIP ();
        selRemoteObj.disabled = true;
        selRemoteObj.readOnly = true;
        document.getElementById('nbWarnMsg').innerHTML = errMsgL10n2;
        fieldStateChangeWr ('selectPolicyType vpnPolicyRemoteendpointIPv6 chkNetbios', '', '','');
        }

    }

function saValueRangeCheck ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid SA Life time value';
    var errMsgL10n2 = 'seconds';
    var errMsgL10n3 = 'KBytes';
    var errMsgObjL10n = document.getElementById ('hd.invalSALfTmVpn');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.secVpn');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.kiloByteVpn');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    /* L10N Error Message Collection end */
        
    var saObj = document.getElementById ('txtVPSALifeTimeSec');
    var selValue = comboSelectedValueGet ('selSaLifetimeType');
    if (selValue == null) return;
    switch (parseInt (selValue, 10))
       {
    case 0:
        return numericValueRangeCheck1 (saObj, '', '', 300, true, errMsgL10n1, errMsgL10n2);
           break;
    case 1:
        return numericValueRangeCheck1 (saObj, '', '', 1920000, true, errMsgL10n1, errMsgL10n3);
           break;
       default:
           break;
       }
}

function pingIPsameSubnetCheck ()
    {
    var keepAliveSelVal = radioCheckedValueGet ('IpsecVPNPolicy.EnableKeepAlive');
    var selRemoteIPVal = comboSelectedValueGet  ('selectRemoteIP');
    if(keepAliveSelVal == 1 && selRemoteIPVal == 3)
        {
        if(!ipv6SubnetValidation1('remoteStartIP','txtPreLen_rmt','keepaliveIPAddress'))
            {
            var errorstr = "Ping IP Address must be in same subnet of Remote IP.";
            alert (errorstr);
            return false;
            }
	    }
	return true;
	}

function rollOverCheck ()
    {
    depFieldCheck ('chkRollOver', true, '', '', 'wan', '');
    depFieldCheck ('chkRollOver', false, 'wan', '', '', '');
   }

function updateWAN ()
    {
    var primary = document.getElementById('selLocGw');
    if (!primary ) return;
    var secondary = document.getElementById('wan');
    if (!secondary ) return;
    deleteOptions (secondary)
    for (idx = 0, i = 0; i < primary.options.length; i++)
        {
        if (primary.options[i].value != primary.value)
            secondary.options[idx++] = new Option(primary.options[i].text, primary.options[i].value, false, false);
        }
    }

function vpnIPv6Init ()
    {
    enableCheck ();
    updateWAN ();
    optionValueSelect('wan', 'hdRollOverWAN');
    rollOverCheck ();
    vpnPolicyAddInitialSettings();
    keepaliveCheck ();
    }
